using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace ComboGDBG
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(16, 16);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(472, 344);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			this.gridDataBoundGrid1.PrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventHandler(this.gridDataBoundGrid1_PrepareViewStyleInfo);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(400, 376);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "Add Row";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(504, 414);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.DataSource = GetParentTable();
			this.gridDataBoundGrid1.EnableRemove = false;
			this.gridDataBoundGrid1.Binder.InternalColumns["PushButton"].StyleInfo.CellType = "PushButton";    
			this.gridDataBoundGrid1.CellButtonClicked +=new GridCellButtonClickedEventHandler(gridDataBoundGrid1_CellButtonClicked);

			
		}

		#region DataTables

		private int numberParentRows = 20;
	
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));

			dt.Columns.Add(new DataColumn("Static",typeof(int))); //lower case p
			dt.Columns.Add(new DataColumn("PushButton"));

			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				if( i % 4 != 0 )
					dr[0] = i;
				dr[1] = string.Format("parentName{0}", i );
				dr[2] = i;
				
				dt.Rows.Add(dr);
			}

			return dt;
		}

		#endregion

		private void gridDataBoundGrid1_PrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventArgs e)
		{
			GridDataBoundGrid grid = sender as GridDataBoundGrid; 
			int staticColIndex = grid.NameToColIndex("Static"); 
			if( e.ColIndex == staticColIndex && e.RowIndex > 0)     
			{
				int pushButtonColIndex = grid.NameToColIndex("PushButton");
				string s  = grid.Model[e.RowIndex,pushButtonColIndex].Text;   
				if( s == null || s == bool.FalseString || s == String.Empty )
					e.Style.CellType = GridCellTypeName.Static;
				else
					e.Style.CellType = GridCellTypeName.NumericUpDown;   

			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.BeginUpdate(); 
			DataTable dt = this.gridDataBoundGrid1.DataSource as DataTable;  
			dt.Rows.Add(new object[]{});
			dt.AcceptChanges();
			this.gridDataBoundGrid1.EndUpdate(true); 
 
		}

		private void gridDataBoundGrid1_CellButtonClicked(object sender, GridCellButtonClickedEventArgs e)
		{
			GridDataBoundGrid grid = sender as GridDataBoundGrid;  
			object obj = grid.Model[e.RowIndex,e.ColIndex].CellValue;
			if( obj == null || obj.ToString() == String.Empty || obj.ToString() == bool.FalseString )
				grid.Model[e.RowIndex,e.ColIndex].CellValue = true;
			else 
				grid.Model[e.RowIndex,e.ColIndex].CellValue = false;
			grid.RefreshRange(GridRangeInfo.Row(e.RowIndex));   

		}
	}
}
